//+------------------------------------------------------------------+
//|                                       ind_AverageValPrice_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 White
#property indicator_color4 Aqua


#property indicator_level1 1

//---- input parameters
extern string  Val_1_List="EURGBP/EURAUD/EURCAD/EURCHF/EURJPY/EURNZD";//GBPUSD/GBPCHF";//
extern string  Val_2_List="GBPUSD/AUDUSD/USDCAD/USDCHF/USDJPY/NZDUSD";//USDJPY/CHFJPY";//
extern int     MAPeriod=90;

string V1A[];
string V2A[];
int    V1A_D[];
int    V2A_D[];

bool DW=false;
string MainSymbol;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
  
      fSplitStrToStr(Val_1_List,V1A,"/");
      fSplitStrToStr(Val_2_List,V2A,"/");  
      string Valuta_1;
         if(!fCheckList(V1A,"Val_1_List",Valuta_1)){
            DW=true;
            return(0);
         }
      string Valuta_2;
         if(!fCheckList(V2A,"Val_2_List",Valuta_2)){
            DW=true;
            return(0);   
         }  
         
       // 
         if(Valuta_1==Valuta_2){
            Alert("  Val_1_List, Val_2_List");
            DW=true;
            return(0);
         }
         
      MainSymbol=Valuta_1+Valuta_2;
      
      ArrayResize(V1A_D,ArraySize(V1A));
         for(int i=0;i<ArraySize(V1A);i++){
            V1A_D[i]=-1;
               if(StringFind(V1A[i],Valuta_1,0)==0){
                  V1A_D[i]=1;
               }
         }
      ArrayResize(V2A_D,ArraySize(V2A));
         for(i=0;i<ArraySize(V2A);i++){
            V2A_D[i]=-1;
               if(StringFind(V2A[i],Valuta_2,0)==0){
                  V2A_D[i]=1;
               }
         }         
         
         
  
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);   
   
   
   SetIndexLabel(0,"  "+Valuta_1);
   SetIndexLabel(1,"  "+Valuta_2);  
   SetIndexLabel(2," "+MainSymbol);      
   SetIndexLabel(3," "+MainSymbol);   
   
   SetIndexDrawBegin(0,100+fMADrawBegin(MAPeriod,0));  
   SetIndexDrawBegin(1,100+fMADrawBegin(MAPeriod,0));     
   SetIndexDrawBegin(2,100+fMADrawBegin(MAPeriod,0));     
   SetIndexDrawBegin(3,100+fMADrawBegin(MAPeriod,0));     
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
            datetime daytimes[];
            static bool err;  
  
               for(int i=0;i<ArraySize(V1A);i++){
               //Alert(V1A[i]," ",iClose(V1A[i],0,0));
                     if(iClose(V1A[i],0,0)==0){
                        Comment("   "+V1A[i]);
                        err=true;
                        return(0);                     
                     }
                  ArrayCopySeries(daytimes,MODE_TIME,V1A[i],0);
                     if(GetLastError()==4066){
                        Comment("   "+V1A[i]);
                        err=true;
                        return(0);
                     }                  
               }
               for(i=0;i<ArraySize(V2A);i++){
                //Alert(V2A[i]," ",iClose(V2A[i],0,0));
                     if(iClose(V2A[i],0,0)==0){
                        Comment("   "+V2A[i]);
                        err=true;
                        return(0);                     
                     }               
                  ArrayCopySeries(daytimes,MODE_TIME,V2A[i],0);
                     if(GetLastError()==4066){
                        Comment("   "+V2A[i]);
                        err=true;
                        return(0);
                     }                  
               }  
                     if(iClose(MainSymbol,0,0)==0){
                        Comment("   "+V2A[i]);
                        err=true;
                        return(0);                     
                     }                
                  ArrayCopySeries(daytimes,MODE_TIME,MainSymbol,0);
                     if(GetLastError()==4066){
                        Comment("   "+MainSymbol);
                        err=true;
                        return(0);
                     } 
            int limit=Bars-IndicatorCounted();//       
               if(err){
                  err=false;
                  limit=Bars;
                  Comment("");
               }
	
	//for(int i=limit-1;i>=0;i--){
   //        int BarNum=iBarShift(NULL,...,Time[i],false); 




   
         //, GBPJPY
         
         // GBP  GBPUSD, GBPCHF
         // JPY  USDJPY, CHFJPY
   
         for(i=limit-1;i>=0;i--){
            double sum1=0;
               for(int j=0;j<ArraySize(V1A);j++){
                  int bn=iBarShift(V1A[j],0,Time[i],false);
                  double m=iMA(V1A[j],0,MAPeriod,0,0,0,bn);
                  double c=iClose(V1A[j],0,bn);
                  //if(i==0)Alert("1 "+V1A_D[j]);
                     if(V1A_D[j]==1){
                        //if(i==0)Alert("1 "+V1A[j]+" "+j);
                        if(m==0)continue;
                        sum1+=c/m;
                        
                     }
                     else{
                        //if(i==0)Alert("2 "+V1A[j]+" "+j);
                        //if(i<10)Alert(i+" 111111111111");
                        if(c==0)continue;
                        sum1+=m/c;
                        
                     }
               }
            sum1/=ArraySize(V1A);
            double sum2=0;
               for(j=0;j<ArraySize(V2A);j++){
                  bn=iBarShift(V2A[j],0,Time[i],false);
                  m=iMA(V2A[j],0,MAPeriod,0,0,0,bn);
                  c=iClose(V2A[j],0,bn);
                  //if(i==0)Alert("2 "+V2A_D[j]);
                     if(V2A_D[j]==1){
                        if(m==0)continue;
                        sum2+=c/m;
                     }
                     else{
                     //if(i==0)Alert("1 "+V2A[j]+" "+j);
                        if(c==0)continue;
                        sum2+=m/c;
                     }
               }
            sum2/=ArraySize(V2A);
            
            if(sum1==0)continue;
            ExtMapBuffer1[i]=sum1;
            ExtMapBuffer2[i]=sum2;
            if(sum2==0)continue;
            ExtMapBuffer3[i]=sum1/sum2; 
            
            bn=iBarShift(MainSymbol,0,Time[i],false);
            m=iMA(MainSymbol,0,MAPeriod,0,0,0,bn);            
            c=iClose(MainSymbol,0,bn);
            if(m==0)continue;
            ExtMapBuffer4[i]=c/m;         
        /* */
         /*
            int bn1=iBarShift("GBPUSD",0,Time[i],false);
            int bn2=iBarShift("GBPCHF",0,Time[i],false);  
            int bn3=iBarShift("USDJPY",0,Time[i],false);              
            int bn4=iBarShift("CHFJPY",0,Time[i],false);                       
            int bn5=iBarShift("GBPJPY",0,Time[i],false);               
         
            double m1=iMA("GBPUSD",0,90,0,0,0,bn1);
            double m2=iMA("GBPCHF",0,90,0,0,0,bn2);  
            if(m1==0 || m2==0)continue;          
            double v1=iClose("GBPUSD",0,bn1)/m1;
            double v2=iClose("GBPCHF",0,bn2)/m2;
            double v12a=(v1+v2)/2;
            ExtMapBuffer1[i]=v12a;// GBP
            
            
            m1=iClose("USDJPY",0,bn3);
            m2=iClose("CHFJPY",0,bn4);  
            if(m1==0 || m2==0)continue;  
            v1=iMA("USDJPY",0,90,0,0,0,bn3)/m1;
            v2=iMA("CHFJPY",0,90,0,0,0,bn4)/m2;
            
            
            double v34a=(v1+v2)/2;
            ExtMapBuffer2[i]=v34a;//  JPY            
            
            
            if(v34a==0)continue;
            ExtMapBuffer3[i]=v12a/v34a;
            
            
            m1=iMA("GBPJPY",0,90,0,0,0,bn5);            
            
            if(m1==0)continue;
            ExtMapBuffer4[i]=iClose("GBPJPY",0,bn5)/m1;
            */
            
            
         }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool fCheckList(string aSymbols[],string aErrText,string & aMatchVal){
         string tV[];
         ArrayResize(tV,ArraySize(aSymbols)*2);
            for(int i=0;i<ArraySize(aSymbols);i++){
               tV[i*2]=fStrLeft(aSymbols[i],3);
               tV[i*2+1]=fStrRight(aSymbols[i],3);
               //Alert(tV[i*2]," ",tV[i*2+1]);
            }
         aMatchVal="";   
            for(i=0;i<ArraySize(tV);i++){
               bool tNotThis=false;
                  for(int j=0;j<ArraySize(aSymbols);j++){
                     if(StringFind(aSymbols[j],tV[i],0)==-1){
                        tNotThis=true;
                        break;
                     }
                  }
                  if(!tNotThis){
                  
                     if(aMatchVal==""){
                        aMatchVal=tV[i];
                     }
                     else{
                        if(aMatchVal!=tV[i]){
                           Alert("  "+aErrText);
                           return(false);
                        }
                     }
                  }
            }
         return(true);
}

string fStrLeft(string aString,int aCount){
   return(StringSubstr(aString,0,aCount));
}

string fStrRight(string aString,int aCount){
   return(StringSubstr(aString,StringLen(aString)-aCount,aCount));
}


int fSplitStrToStr(string aString,string & aArray[],string aDelimiter){
string tmp_str="";
string tmp_char="";
ArrayResize(aArray,0);
   for(int i=0;i<StringLen(aString);i++){
      tmp_char=StringSubstr(aString,i,1);
         if(tmp_char==aDelimiter){
               if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
                  ArrayResize(aArray,ArraySize(aArray)+1);
                  aArray[ArraySize(aArray)-1]=tmp_str;
               }
            tmp_str="";
         }
         else{
            if(tmp_char!=" ")tmp_str=tmp_str+tmp_char;
         }
   }
   if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
      ArrayResize(aArray,ArraySize(aArray)+1);
      aArray[ArraySize(aArray)-1]=tmp_str;
   } 
return(ArraySize(aArray));
}

int fMADrawBegin(int aPeriod,int aMethod){
      switch(aMethod){
         case 1: return(10*aPeriod);
         case 2: return(20*aPeriod);      
      }
   return(aPeriod);    
}

